﻿using Bizgaze.CRM;
using Bizgaze.CRM.Visitors.Managers;
using System;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Text.Json;
using System.Threading.Tasks;
using Unibase.Data;
using Unibase.Data.Expressions;
using Unibase.Data.Sql;
using Unibase.Dependency;
using Unibase.Platform.Apps.Managers;
using Unibase.Platform.Data;
using Unibase.Platform.Forms.Providers;
using Unibase.Platform.Keys;

namespace Bizgaze.CRM.Visitors.ActionProviders
{
    public class UpdateVisitorBeenHerePreAction : BaseFormActionProvider, IFormActionProvider
    {
        public string ControllerClass
        {
            get
            {
                return "Bizgaze.CRM.Visitors.ActionProviders.UpdateVisitorBeenHerePreAction";

            }
        }
        public string FormActionName
        {
            get
            {
                return "UpdateVisitorBeenHere";
            }
        }
        public string Description
        {
            get
            {
                return "Update Visitor Been Here PreAction";
            }
        }
        public UniqueKey UniqueId
        {
            get
            {
                return Bizgaze.CRM.Actions.UpdateVisitorBeenHere;
            }
        }
        public int ActionType
        {
            get
            {
                return (int)Unibase.Platform.Forms.Enums.FormActionProvider.PreAction;
            }
        }
        //public ActionResponse<ExpandoObject> Execute(ActionRequest request, object IdValue, ExpandoObject obj, List<Unibase.Platform.Forms.Requests.DocParameter> docParametersList, ref long defaultPKValue)
        //{
        //    return null;

        //}
        public async Task<ActionResponse<FormActionResponse>> ExecuteAsync(ActionRequest request, FormActionProviderObject providerObject)
        {
            var IdValue = providerObject.IdValue;
            var srequest = SelectRequest.FromRequest(request);
            var obj = providerObject.RequestObject;
            var returnresponse = new FormActionResponse();           
            var defaultPKValue = providerObject.DefaultPKValue;
            var stageManager = Unibase.Dependency.DependencyConfig.Resolve<IStageManager>();
            var visitorManager = Unibase.Dependency.DependencyConfig.Resolve<Bizgaze.CRM.Visitors.Managers.IVisitorManager>();
            var dictObj = obj as IDictionary<string, dynamic>;
            var MobileNumber = dictObj["mobilenumber"].ToString();
            long visitorid = 0;
            var visitorsinfo = await visitorManager.VisitorsbyMobileNumberAsync(srequest, MobileNumber);
            var stageStatusName = "";
            if (visitorsinfo.Result != null)
            {
                stageStatusName = "CheckIn";
                visitorid = visitorsinfo.Result.VisitorId;
                dictObj["visitorid"] = visitorid;
                dictObj["visitoremailid"] = visitorsinfo.Result.VisitorEmailId;
                dictObj["visitornumberid"] = visitorsinfo.Result.VisitorNumberId;
                var installedAppId = visitorsinfo.Result.Installedappid;
                var stage = await stageManager.GetStageByStageStatusAsync(srequest, installedAppId, stageStatusName);
                var NewStageId = stage.Result.StageId;
                var UpdateStage = new Update("bizgazecrm_visitors").Value("stageid", NewStageId).Where(Exp.Eq("visitorId", visitorid));
                await _repository.ExecuteAsync(request, UpdateStage);
            } 
            else
            {
                return ActionResponse<FormActionResponse>.CreateErrorResponse("1", "visitor  Not Found");
            }
            var updateValues = new Dictionary<string, object>();
            updateValues.Add("agreement", true);
            updateValues.Add("checkindate", DateTime.Now);
            var updateQry = new Update("bizgazecrm_visitors").Values(updateValues).Where(Exp.Eq("visitorid", visitorid));
            var ds = await _repository.ExecuteAsync(request, updateQry);
            var UpdateCheckoutDate = new Update("bizgazecrm_visitorcheckout").Value("checkoutdate", DateTime.MinValue).Where(Exp.Eq("visitorId", visitorid));
            await _repository.ExecuteAsync(request, UpdateCheckoutDate);
            returnresponse.Obj = dictObj as ExpandoObject;
            returnresponse.PkValue = defaultPKValue;
            return ActionResponse<FormActionResponse>.CreateSuccessResponse("success", returnresponse);
        }
        public List<UniqueKey> AppliedApps
        {
            get
            {
                return new List<UniqueKey>() {
                    Bizgaze.CRM.Actions.UpdateVisitorBeenHere,
            };
            }
        }

    }
}
